import { TPluginCfg } from "../parseConfigFile";
import { Dictionary } from "../stl";
export declare type TPluginState = "uninitialized" | "initialized";
export declare type TOutput = void | TFileDesc | TFileDesc[];
export declare abstract class TsGeneratorPlugin {
    readonly ctx: TContext;
    state: TPluginState;
    abstract readonly name: string;
    constructor(ctx: TContext);
    beforeRun(): TOutput | Promise<TOutput>;
    afterRun(): TOutput | Promise<TOutput>;
    abstract transformFile(file: TFileDesc): TOutput | Promise<TOutput>;
}
export interface TContext<T = Dictionary<any>> {
    cwd: string;
    rawConfig: TPluginCfg<T>;
}
export interface TFileDesc {
    path: string;
    contents: string;
}
